
JSB.newAddon = function (mainPath) {
  JSB.require('webviewController');
  var entries = {
    Bing:             { title: '🔍 Bing',           symbol: "🔍", engine: "Bing",     link: "https://www.bing.com/search?q=%s" },
    Baidu:            { title: '🔍 Baidu',          symbol: "🔍", engine: "Baidu",    link: "https://www.baidu.com/s?wd=%s" },
    Zhihu:            { title: '🔍 Zhihu',          symbol: "🔍", engine: "Zhihu",    link: "https://www.zhihu.com/search?type=content&q=%s" },
    Google:           { title: '🔍 Google',         symbol: "🔍", engine: "Google",   link: "https://www.google.com/search?q=%s" },
    Yandex:           { title: '🔍 Yandex',         symbol: "🔍", engine: "Yandex",   link: "https://yandex.com/search/?text=%s" },
    Sougou:           { title: '🔍 Sougou',         symbol: "🔍", engine: "Sougou",   link: "https://www.sogou.com/web?query=%s" },
    Wikipedia:        { title: '🔍 Wikipedia',      symbol: "🔍", engine: "Wiki",     link: "https://www.wikipedia.org/w/index.php?search=%s" },
    BaiduTranslate:   { title: '📔 Baidu',          symbol: "📔", engine: "Baidu",    link: "https://fanyi.baidu.com/#en/zh/%s" },
    Deepl:            { title: '📔 Deepl',          symbol: "📔", engine: "Deepl",    link: "https://www.deepl.com/translator#en/zh/%s" },
    GoogleTranslate:  { title: '📔 Google',         symbol: "📔", engine: "Google",   link: "https://translate.google.com/?sl=en&tl=zh-CN&text=%s&op=translate" },
    Notion:           { title: '📝 Notion',         symbol: "📝", engine: "Notion",   link: "https://www.notion.so" },
    Wolai:            { title: '📝 Wolai',          symbol: "📝", engine: "Wolai",    link: "https://www.wolai.com" },    
    Craft:            { title: '📝 Craft',          symbol: "📝", engine: "Craft",    link: "https://docs.craft.do" },
    Flomo:            { title: '📝 Flomo',          symbol: "📝", engine: "Flomo",    link: "https://v.flomoapp.com/mine" },
    Flowus:           { title: '📝 Flowus',         symbol: "📝", engine: "Flowus",   link: "https://flowus.cn" },
    Baiduyun:         { title: '☁️ Baiduyun',        symbol: "☁️", engine: "Baidu",    link: "https://pan.baidu.com/disk/main#/index?category=all" },
    Bilibili:         { title: '📺 Bilibili',       symbol: "📺", engine: "Bilibili", link: "https://m.bilibili.com/" },
    GoogleScholar:    { title: '🎓 Google Scholar', symbol: "🎓", engine: "Scholar",  link: "https://scholar.google.com/scholar?q=%s" },
    ResearchGate:     { title: '🎓 ResearchGate',   symbol: "🎓", engine: "RG",       link: "https://www.researchgate.net/search.Search.html?query=%s" },
  }
  var textSelected = "";
  var temSender;
  var textProcessed = false;
  var watchMode = false;
  var dateNow = Date.now();
  var dateGetText = Date.now();
  var isNewVideoWindow = false;
  var isNewWindow = false;

  var MNBrowserClass = JSB.defineClass(
    'MNBrowser : JSExtension',
    { /* Instance members */
      sceneWillConnect: function () { //Window initialize
        self.appInstance = Application.sharedInstance();
        self.addonController = browserController.new();
        self.addonController.mainPath = mainPath;
        self.addonController.entries = entries
        self.selectionText = '';
        self.rect = '{{0, 0}, {10, 10}}';
        self.arrow = 1;
        // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'trst:', 'onReciveTrst');
        // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onClosePopupMenuOnSelection:', 'ClosePopupMenuOnSelection');
      },

      sceneDidDisconnect: function () { // Window disconnect
      },

      sceneWillResignActive: function () { // Window resign active
      },

      sceneDidBecomeActive: function () { // Window become active
      },

      notebookWillOpen: function (notebookid) {
        if (self.appInstance.studyController(self.window).studyMode < 3) {
          self.appInstance.studyController(self.window).refreshAddonCommands();
          self.appInstance.studyController(self.window).view.addSubview(self.addonController.view);
          self.addonController.view.hidden = true;

          NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onPopupMenuOnSelection:', 'PopupMenuOnSelection');
          // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onClosePopupMenuOnSelection:', 'ClosePopupMenuOnSelection');
          NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onPopupMenuOnNote:', 'PopupMenuOnNote');
          // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onClosePopupMenuOnNote:', 'ClosePopupMenuOnNote');
          NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onCloseView:', 'close');
          NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onNewWindow:', 'newWindow');
          NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onNewVideoWindow:', 'newVideoWindow');


          let engine = NSUserDefaults.standardUserDefaults().objectForKey('MNBrowser_engine');
          let toolbar = NSUserDefaults.standardUserDefaults().objectForKey('MNBrowser_toolbar');
          if (engine) {
            self.addonController.engine = engine
            self.addonController.searchButton.setTitleForState(entries[engine].symbol, 0);
            self.addonController.engineButton.setTitleForState(entries[engine].engine, 0);
          }
          if (toolbar !== undefined) {
            self.addonController.toolbarOn = toolbar
            self.addonController.opacityButton.hidden = !toolbar
            // self.addonController.searchButton.hidden = !toolbar
            self.addonController.homeButton.hidden = !toolbarOn
            self.addonController.goBackButton.hidden = !toolbarOn
            self.addonController.goForwardButton.hidden = !toolbarOn
            self.addonController.refreshButton.hidden = !toolbarOn
            // self.addonController.screenButton.hidden = !toolbarOn
            self.addonController.engineButton.hidden = !toolbarOn
            var viewFrame = self.addonController.view.bounds;
            if (self.addonController.toolbarOn) {
              self.addonController.webview.frame = { x: viewFrame.x + 1, y: viewFrame.y + 10, width: viewFrame.width - 2, height: viewFrame.height - 40 }
            } else {
              self.addonController.webview.frame = { x: viewFrame.x + 1, y: viewFrame.y + 10, width: viewFrame.width - 2, height: viewFrame.height }
            }
          }
          NSTimer.scheduledTimerWithTimeInterval(0.2, false, function () {
            self.appInstance.studyController(self.window).becomeFirstResponder(); //For dismiss keyboard on iOS
          });
        }
      },

      notebookWillClose: function (notebookid) {
        // Application.sharedInstance().showHUD("close",self.window,2)
        self.addonController.homePage()
        watchMode = false;
        textSelected = '';
        NSNotificationCenter.defaultCenter().removeObserverName(self, 'PopupMenuOnSelection');
        NSNotificationCenter.defaultCenter().removeObserverName(self, 'ClosePopupMenuOnSelection');
      },

      documentDidOpen: function (docmd5) {
      },

      documentWillClose: function (docmd5) {
      },

      controllerWillLayoutSubviews: function (controller) {
        if (controller === self.appInstance.studyController(self.window)) {
          if (self.addonController.miniMode) {
            let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
            let oldFrame = self.addonController.view.frame
            if (oldFrame.x < studyFrame.width) {
              self.addonController.view.frame = { x: 0, y: oldFrame.y, width: oldFrame.width, height: oldFrame.height }
            } else {
              self.addonController.view.frame = { x: studyFrame.width - 40, y: oldFrame.y, width: oldFrame.width, height: oldFrame.height }
            }
          } else if (self.addonController.custom) {
            let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
            let height = studyFrame.height-35;
            let splitLine = getSplitLine()
            switch (self.addonController.customMode) {
              case "left":
                self.addonController.view.frame = { x: 40, y: 25, width: splitLine - 45, height: height }
                break;
              case "left13":
                self.addonController.view.frame = { x: 40, y: 25, width: studyFrame.width / 3. + 40, height: height}
                break;
              case "right":
                self.addonController.view.frame = { x: splitLine + 5, y: 25, width: studyFrame.width - splitLine - 45, height: height }
                break;
              case "right13":
                self.addonController.view.frame = { x: studyFrame.width * 2 / 3. - 40, y: 25, width: studyFrame.width / 3., height: height }
                break;
              case "full":
                self.addonController.view.frame = { x: 40, y: 25, width: studyFrame.width - 80, height: height }
                break;
              default:
                break;
            }
            self.addonController.webview.frame = self.addonController.view.bounds
          }
        }
      },

      queryAddonCommandStatus: function () {
        if (self.appInstance.studyController(self.window).studyMode < 3) {
          return {
            image: 'logo.png',
            object: self,
            selector: 'toggleAddon:',
            checked: watchMode
          };
        } else {
          return null;
        }
      },

      onPopupMenuOnSelection: function (sender) { // Selecting text on pdf or epub
        isOnSelection = true
        textSelected = sender.userInfo.documentController.selectionText;
        Application.sharedInstance().showHUD(isNewWindow,self.window,2)
        self.addonController.selectedText = textSelected
        if (isNewWindow) {
          self.newWindowController.selectedText = textSelected
        }
        dateGetText = Date.now();
        textProcessed = false
        temSender = sender
        if (!self.appInstance.checkNotifySenderInWindow(sender, self.window)) return; // Don't process message from other window
        if (!self.addonController.view.window) return;
        if (self.viewTimer) self.viewTimer.invalidate();
        if (!watchMode) {
          self.addonController.searchButton.backgroundColor = UIColor.colorWithHexString("#6d94d3").colorWithAlphaComponent(0.8);
          if (isNewWindow) {
            self.newWindowController.searchButton.backgroundColor = UIColor.colorWithHexString("#6d94d3").colorWithAlphaComponent(0.8);
          }
          self.viewTimer = NSTimer.scheduledTimerWithTimeInterval(5, false, function () {
            self.addonController.searchButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
            if (isNewWindow) {
              self.newWindowController.searchButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
            }
            self.viewTimer.invalidate()
          });
          return
        }
        var text = sender.userInfo.documentController.selectionText;
        if (text && text.length) {
          self.addonController.search(text);
          if (self.addonController.dynamic) {
            self.layoutAddonController(sender.userInfo.winRect, sender.userInfo.arrow);
          }
          self.addonController.view.hidden = false;
          self.selectionText = text;
        }
      },

      onPopupMenuOnNote: function (sender) { // Clicking note
        isOnNote = true
        // const frame = self.addonController.view.frame
        // const frameText = `{x:${frame.x},y:${frame.y},width:${frame.width},height:${frame.height}}`
        // Application.sharedInstance().showHUD(frameText,self.window,5)
        currentNoteId = sender.userInfo.note.noteId
        // Application.sharedInstance().showHUD(self.addonController.watchMode,self.window,2)
        let note = Database.sharedInstance().getNoteById(sender.userInfo.note.noteId)
        // Application.sharedInstance().showHUD(note,self.window,2)
        textSelected = note.excerptText ?? note.noteTitle
        self.addonController.selectedText = textSelected
        if (isNewWindow) {
          self.newWindowController.selectedText = textSelected
        }
        dateGetText = Date.now();
        textProcessed = false
        temSender = sender
        // Application.sharedInstance().showHUD(sender.userInfo.note,self.window,2)
        if (!self.appInstance.checkNotifySenderInWindow(sender, self.window)) return; // Don't process message from other window
        if (!self.addonController.view.window) return;
        if (self.viewTimer) self.viewTimer.invalidate();
        if (!watchMode) {
          self.addonController.searchButton.backgroundColor = UIColor.colorWithHexString("#6d94d3").colorWithAlphaComponent(0.8);
          if (isNewWindow) {
            self.newWindowController.searchButton.backgroundColor = UIColor.colorWithHexString("#6d94d3").colorWithAlphaComponent(0.8);
          }
          self.viewTimer = NSTimer.scheduledTimerWithTimeInterval(5, false, function () {
            self.addonController.searchButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
            if (isNewWindow) {
              self.newWindowController.searchButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
            }
            self.viewTimer.invalidate()
          });
          return
        }
        if (textSelected && textSelected.length) {
          self.addonController.search(textSelected);
          if (self.addonController.dynamic) {
            self.layoutAddonController(sender.userInfo.winRect, sender.userInfo.arrow);
          }
          self.addonController.view.hidden = false;
          self.selectionText = textSelected;
        }
        // self.addonController.view.frame = {x:0,y:0,width:100,height:100}
      },
      onCloseView: function (params) {
        watchMode = false;
        self.appInstance.studyController(self.window).refreshAddonCommands();
        var url = self.addonController.homePageURL
        // var url = 'https://go.itab.link/'
        self.addonController.webview.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(url)));
        // custom = true;
        // self.appInstance.studyController(self.window).view.addSubview(self.addonController.view);

        // self.customLayoutAddonController(123);
        // Application.sharedInstance().showHUD("trst",self.window,2)
        // try {
        // self.layoutAddonController(0,0,true)

        // } catch (error) {
        // Application.sharedInstance().showHUD(error,self.window,2)

        // }
      },
      onNewWindow: function ({userInfo}) {
        if (!isNewWindow) {
          self.newWindowController = browserController.new();
          self.newWindowController.mainPath = mainPath;
          self.newWindowController.entries = entries
          self.appInstance.studyController(self.window).view.addSubview(self.newWindowController.view);
          isNewWindow = true
        }
        self.newWindowController.isMainWindow = false
        self.newWindowController.webview.hidden = false;
        self.newWindowController.view.hidden = false;
        self.newWindowController.view.frame = {x:50,y:100,width:400,height:450}
        // Application.sharedInstance().showHUD(userInfo.url, self.window, 5);
        if (userInfo.url !== self.newWindowController.homePageURL) {
          self.newWindowController.webview.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(userInfo.url)));
        }
      },
      onNewVideoWindow: function ({userInfo}) {
        if (!isNewVideoWindow) {
          self.newVideoController = browserController.new();
          self.newVideoController.mainPath = mainPath;
          self.newVideoController.entries = entries
          self.appInstance.studyController(self.window).view.addSubview(self.newVideoController.view);
          isNewVideoWindow = true
        }
        self.newVideoController.isMainWindow = false
        self.newVideoController.view.frame = {x:50,y:100,width:500,height:300}
        self.newVideoController.webview.hidden = false;
        self.newVideoController.view.hidden = false;
        self.newVideoController.webview.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(userInfo.url)));
        self.viewTimer = NSTimer.scheduledTimerWithTimeInterval(0.5, true, () => {
          self.newVideoController.webview.evaluateJavaScript(
              `try {
        document.getElementsByClassName("m-navbar")[0].style.display = "none";
        let itemToRemove = document.getElementsByClassName("openapp-dialog large")[0]
      itemToRemove.parentNode.removeChild(itemToRemove)
        itemToRemove = document.getElementsByClassName("fixed-module")[0]
      itemToRemove.parentNode.removeChild(itemToRemove)
      } catch (error) {
        
      }
    var body = document.getElementsByTagName("body");
              var div = document.createElement("div");
              div.innerHTML = '<iframe class="embedPlayer" style="position: absolute; width: 100%; height: 100%; left: 0; top: 0;" src="//player.bilibili.com/player.html?bvid=${userInfo.bid}&high_quality=1" scrolling="no" border="0" frameborder="no" framespacing="0"></iframe> ';
              document.body.appendChild(div);`,
              (ret) => {}
            );
            self.viewTimer.invalidate();
        });
    //     self.newVideoController.webview.evaluateJavaScript(
    //     `var body = document.getElementsByTagName("body");
    // var div = document.createElement("div");
    // div.innerHTML = '<iframe class="embedPlayer" style="position: absolute; width: 100%; height: 100%; left: 0; top: 0;" src="//player.bilibili.com/player.html?bvid=BV1uN411S7Zy&high_quality=1" scrolling="no" border="0" frameborder="no" framespacing="0"></iframe> ';
    // document.body.appendChild(div);`,
    //     (ret) => {
    //     ;
    //   })
      },
      toggleAddon: function (sender) {
        if (Date.now() - dateNow < 500) {
          watchMode = true;
          Application.sharedInstance().showHUD("watch mode", self.window, 2)
          self.appInstance.studyController(self.window).refreshAddonCommands();
          
          return;
        }

        dateNow = Date.now();
        // NSUserDefaults.standardUserDefaults().setObjectForKey(true, 'MNAddon_MdxDict_On');
        // NSUserDefaults.standardUserDefaults().setObjectForKey(true, 'MNAddon_MdxDict_On');
        // popUpOn = true;
        if (self.addonController.view.hidden) {
          self.appInstance.studyController(self.window).view.addSubview(self.addonController.view);
        } else {
          if (textProcessed || watchMode) {
            self.addonController.view.hidden = true;
            self.addonController.minimized = false
            self.addonController.miniMode = false
            watchMode = false;
            self.appInstance.studyController(self.window).refreshAddonCommands();
            return;
          }
        }
        // self.addonController.view.hidden = true;
        // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onPopupMenuOnSelection:', 'PopupMenuOnSelection');
        // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onClosePopupMenuOnSelection:', 'ClosePopupMenuOnSelection');
        NSTimer.scheduledTimerWithTimeInterval(0.2, false, function () {
          self.appInstance.studyController(self.window).becomeFirstResponder(); // For dismiss keyboard on iOS
        });
        if (!self.appInstance.checkNotifySenderInWindow(temSender, self.window)) {
          self.appInstance.studyController(self.window).view.addSubview(self.addonController.view);
          self.addonController.webview.hidden = false;
          // try {
          // self.addonController.homePage('');

          // } catch (error) {

          // Application.sharedInstance().showHUD(error,self.window,2)
          // }
          self.addonController.minimized = false;
          self.addonController.miniMode = false
          if (self.addonController.dynamic) {
            self.customLayoutAddonController();
          }
          self.addonController.view.hidden = false;
          self.addonController.closeButton.hidden = false
          self.addonController.maxButton.hidden = false
          self.addonController.screenButton.hidden = false
          self.addonController.searchButton.hidden = false
          // Application.sharedInstance().showHUD(self.addonController.toolbarOn,self.window,2)
          self.addonController.engineButton.hidden = !self.addonController.toolbarOn
          self.addonController.goBackButton.hidden = !self.addonController.toolbarOn
          self.addonController.goForwardButton.hidden = !self.addonController.toolbarOn
          self.addonController.refreshButton.hidden = !self.addonController.toolbarOn
          self.addonController.opacityButton.hidden = !self.addonController.toolbarOn
          self.addonController.homeButton.hidden = !self.addonController.toolbarOn

          textProcessed = true
          return; // Don't process message from other window
        }
        if (!self.addonController.view.window) return;
        if (self.viewTimer) self.viewTimer.invalidate();
        // Application.sharedInstance().showHUD("123",self.window,2)
        var text = textSelected;
        if (text && text.length && !self.addonController.minimized && (Date.now() - dateGetText < 5000)) {
          // self.addonController.view.frame = {x:0,y:0,width:100,height:100}
          self.addonController.search(text);
          // self.addonController.homePage(text);
          // self.customLayoutAddonController();
          if (self.addonController.dynamic) {
            self.layoutAddonController(temSender.userInfo.winRect, temSender.userInfo.arrow);
          }
          self.addonController.view.hidden = false;
          self.addonController.minimized = false;
          self.addonController.miniMode = false
          self.addonController.closeButton.hidden = false
          self.addonController.maxButton.hidden = false
          self.addonController.screenButton.hidden = false
          self.addonController.searchButton.hidden = false
          self.addonController.engineButton.hidden = !self.addonController.toolbarOn
          self.addonController.goBackButton.hidden = !self.addonController.toolbarOn
          self.addonController.goForwardButton.hidden = !self.addonController.toolbarOn
          self.addonController.refreshButton.hidden = !self.addonController.toolbarOn
          self.addonController.opacityButton.hidden = !self.addonController.toolbarOn
          self.addonController.homeButton.hidden = !self.addonController.toolbarOn

          self.selectionText = text;
          textProcessed = true
        } else {
          textProcessed = true
          // self.addonController.homePage(text);
          // Application.sharedInstance().showHUD("No note or text selected",self.window,2)
          if (self.addonController.dynamic) {
            self.layoutAddonController(temSender.userInfo.winRect, temSender.userInfo.arrow);
          }
          self.addonController.view.hidden = false;
          self.addonController.minimized = false;
          self.addonController.miniMode = false
          self.addonController.closeButton.hidden = false
          self.addonController.maxButton.hidden = false
          self.addonController.screenButton.hidden = false
          self.addonController.searchButton.hidden = false
          self.addonController.engineButton.hidden = !self.addonController.toolbarOn
          self.addonController.goBackButton.hidden = !self.addonController.toolbarOn
          self.addonController.goForwardButton.hidden = !self.addonController.toolbarOn
          self.addonController.refreshButton.hidden = !self.addonController.toolbarOn
          self.addonController.opacityButton.hidden = !self.addonController.toolbarOn
          self.addonController.homeButton.hidden = !self.addonController.toolbarOn
        }
      },
    },
    { /* Class members */
      addonDidConnect: function () {
      },

      addonWillDisconnect: function () {
      },

      applicationWillEnterForeground: function () {
      },

      applicationDidEnterBackground: function () {
      },

      applicationDidReceiveLocalNotification: function (notify) {
      }
    }
  );

  MNBrowserClass.prototype.layoutAddonController = function (rectStr, arrowNum, custom = false) {

    this.rect = rectStr || this.rect;
    this.arrow = arrowNum || this.arrow;
    var x, y
    w = (this.appInstance.osType !== 1) ? 400 : 365, // this.addonController.view.frame.width
      h = 500, // this.addonController.view.frame.height
      fontSize = 15,
      margin = 10,
      padding = 20,
      frame = this.appInstance.studyController(this.window).view.bounds,
      W = frame.width,
      H = frame.height,
      rectArr = this.rect.replace(/{/g, '').replace(/}/g, '').replace(/\s/g, '').split(','),
      X = Number(rectArr[0]),
      Y = Number(rectArr[1]),
      studyMode = this.appInstance.studyController(this.window).studyMode,
      contextMenuWidth = studyMode === 0 ? 225 : 435,
      contextMenuHeight = 35,
      textMenuPadding = 40;

    // this.addonController.view.frame.x
    if (w >= contextMenuWidth) {
      if (X - w / 2 - margin <= 0) {
        x = margin;
      } else if (X + w / 2 + margin >= W) {
        x = W - margin - w;
      } else {
        x = X - w / 2;
      }
    } else {
      if (X - contextMenuWidth / 2 - margin <= 0) {
        x = margin + contextMenuWidth / 2 - w / 2;
      } else if (X + contextMenuWidth / 2 + margin >= W) {
        x = W - margin - contextMenuWidth / 2 - w / 2;
      } else {
        x = X - w / 2;
      }
    }

    // this.addonController.view.frame.[y, height]
    if (this.arrow === 1) {
      let upperBlankHeight = Y - textMenuPadding - fontSize - padding,
        lowerBlankHeight = H - Y - contextMenuHeight - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
      }
    } else {
      let upperBlankHeight = Y - textMenuPadding - contextMenuHeight - padding,
        lowerBlankHeight = H - Y - fontSize - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
      }
    }
    // if (custom) {
    //     Application.sharedInstance().showHUD("custom",self.window,2)

    //   this.addonController.view.frame = {x:0,y:0,width:500,height:h-100};
    //   return
    // }
    this.addonController.view.frame = { x: x, y: y, width: w, height: h };
    // Application.sharedInstance().showHUD(this.addonController.view.frame,self.window,2)
  };
  MNBrowserClass.prototype.customLayoutAddonController = function (rectStr, arrowNum, custom = false) {

    this.rect = rectStr || this.rect;
    this.arrow = arrowNum || this.arrow;
    var x, y
    w = (this.appInstance.osType !== 1) ? 400 : 365, // this.addonController.view.frame.width
      h = 450, // this.addonController.view.frame.height
      fontSize = 15,
      margin = 10,
      padding = 20,
      frame = this.appInstance.studyController(this.window).view.bounds,
      W = frame.width,
      H = frame.height,
      rectArr = this.rect.replace(/{/g, '').replace(/}/g, '').replace(/\s/g, '').split(','),
      X = Number(rectArr[0]),
      Y = Number(rectArr[1]),
      studyMode = this.appInstance.studyController(this.window).studyMode,
      contextMenuWidth = studyMode === 0 ? 225 : 435,
      contextMenuHeight = 35,
      textMenuPadding = 40;

    // this.addonController.view.frame.x
    if (w >= contextMenuWidth) {
      if (X - w / 2 - margin <= 0) {
        x = margin;
      } else if (X + w / 2 + margin >= W) {
        x = W - margin - w;
      } else {
        x = X - w / 2;
      }
    } else {
      if (X - contextMenuWidth / 2 - margin <= 0) {
        x = margin + contextMenuWidth / 2 - w / 2;
      } else if (X + contextMenuWidth / 2 + margin >= W) {
        x = W - margin - contextMenuWidth / 2 - w / 2;
      } else {
        x = X - w / 2;
      }
    }

    // this.addonController.view.frame.[y, height]
    if (this.arrow === 1) {
      let upperBlankHeight = Y - textMenuPadding - fontSize - padding,
        lowerBlankHeight = H - Y - contextMenuHeight - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
      }
    } else {
      let upperBlankHeight = Y - textMenuPadding - contextMenuHeight - padding,
        lowerBlankHeight = H - Y - fontSize - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
      }
    }
    // if (custom) {
    //     Application.sharedInstance().showHUD("custom",self.window,2)

    //   this.addonController.view.frame = {x:0,y:0,width:500,height:h-100};
    //   return
    // }
    this.addonController.view.frame = { x: x, y: y + 50, width: w, height: h };
    // Application.sharedInstance().showHUD(this.addonController.view.frame,self.window,2)
  };
  return MNBrowserClass;
};